#	Generates input for Ultimod
#       n1=nx
#	n2=nz
#%
#	KEYWORDS    elastic modelling isotropic 

 	implicit none 
	integer nmax,i,j

	Parameter(nmax=1024)
	integer input,output,infd,outfd,esize,n1,n2,n3,symmetry
	real plane(nmax,nmax),lambda,mu,c11,c13,c33,c44,rho,vp,vs,d1,d2

	call initpar()
	symmetry=1
	esize=4 
	outfd=output()
 
	call fetch('symmetry','d',symmetry)
	if (symmetry==1) {  #isotropic
	call fetch('vp','r',vp)
	call fetch('vs','r',vs)
	call putch('vp','r',vp)
	call putch('vs','r',vs)
	n3=3
	}else if (symmetry==2){   #transverse isotropic
        call fetch('c11','r',c11)
        call fetch('c13','r',c13)
        call fetch('c33','r',c33)
        call fetch('c44','r',c44)
        call putch('c11','r',c11)
        call putch('c13','r',c13)
        call putch('c33','r',c33)
        call putch('c44','r',c44)
	call fetch('vp','r',vp)
	call fetch('vs','r',vs)
	n3=5 }

	call fetch('nx','d',n1)
	call fetch('nz','d',n2)
	call fetch('dx','r',d1)
	call fetch('dz','r',d2)
	call fetch('rho','r',rho)
	d1=d1/1000.
	d2=d2/1000.
	call putch('n1','d',n1)
	call putch('n2','d',n2)
	call putch('n3','d',n3)
	call putch('d1','r',d1)
	call putch('d2','r',d2)
	call putch('rho','r',rho)
	call putch('esize','d',esize)
	call hclose()


	if (symmetry==2 ) {
 
		if (c11==0) {
			lambda =  rho *( vp*vp - 2*vs*vs)
			mu = rho*vs*vs
			c11 = lambda+2*mu
			c13 = lambda
			c33 = lambda+2*mu
			c44 = mu
		}
	do i=1,n1 {
	 do j=1,n2 
		plane(j,i) = c11
		call srite('out',plane(1,i),n2*esize) 
		#call rite(outfd,plane(1,i),n2*esize) 
		}
	do i=1,n1 {
	 do j=1,n2 
		plane(j,i) = c13
	call srite('out',plane(1,i),n2*esize) 
	#call rite(outfd,plane(1,i),n2*esize) 
		}
	do i=1,n1 {
	 do j=1,n2 
		plane(j,i) = c33
	call srite('out',plane(1,i),n2*esize) 
	#call rite(outfd,plane(1,i),n2*esize) 
		}
	do i=1,n1 {
	 do j=1,n2 
		plane(j,i) = c44
	call srite('out',plane(1,i),n2*esize) 
	#call rite(outfd,plane(1,i),n2*esize) 
		}
	do i=1,n1 {
	 do j=1,n2 
		plane(j,i) = rho
	call srite('out',plane(1,i),n2*esize) 
	#call rite(outfd,plane(1,i),n2*esize) 
		}
	}
		else if (symmetry==1) {
#	rho = rho/1000
#	vp = vp/1000.
#	vs = vs/1000.

	lambda =  rho *( vp*vp - 2*vs*vs)
	mu = rho*vs*vs
	
	do i=1,n1 {
	 do j=1,n2 
		plane(j,i) = lambda
	call srite('out',plane(1,i),n2*esize) 
	#call rite(outfd,plane(1,i),n2*esize) 
		}
	do i=1,n1 {
	 do j=1,n2 
		plane(j,i) = mu
	call srite('out',plane(1,i),n2*esize) 
	#call rite(outfd,plane(1,i),n2*esize) 
		}
	do i=1,n1 {
	 do j=1,n2 
		plane(j,i) = rho
	call srite('out',plane(1,i),n2*esize) 
	#call rite(outfd,plane(1,i),n2*esize) 
		}
	}
	call exit(0)
	end




